#ifndef EFL_GENERATED_EVAS_SIGNAL_INTERFACE_HH
#define EFL_GENERATED_EVAS_SIGNAL_INTERFACE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_signal_interface.eo.h"
}


namespace evas {

struct signal_interface
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit signal_interface(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit signal_interface(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   signal_interface(signal_interface const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~signal_interface() {}

   static Eo_Class const* _eo_class()
   {
      return(EVAS_SIGNAL_INTERFACE_INTERFACE);
   }

private:
};
} 

namespace efl { namespace eo { namespace detail {

template<>
struct operations< evas::signal_interface >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< evas::signal_interface >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<evas::signal_interface>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< evas::signal_interface >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::signal_interface, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< evas::signal_interface>
{
   template <typename U>
   struct type
   {
      operator evas::signal_interface() const
      {
         return evas::signal_interface(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<evas::signal_interface>)
{
   return (EVAS_SIGNAL_INTERFACE_INTERFACE);
}

} } }
#endif // EFL_GENERATED_EVAS_SIGNAL_INTERFACE_HH

